<script setup lang="ts">
// ----------------------------------------------------------------
// Import
// ----------------------------------------------------------------

import { useSampleStore } from "@/stores/useSampleStore";
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";
import { onMounted, ref, watch } from "vue";

// ----------------------------------------------------------------
// PROPS
// ----------------------------------------------------------------

const props = defineProps({
  multipleHeritageDialog: {
    type: Boolean,
    required: true,
  },
  currentItem: {
    type: Object,
    required: true,
  },
  objectRelated: {
    type: Object,
    required: true,
  },
});

// ----------------------------------------------------------------
// EMITS
// ----------------------------------------------------------------

const emits = defineEmits(["multipleHeritageDialog", "close", "redirect"]);

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------

const workspaceStore = useWorkspaceStore();
const sampleStore = useSampleStore();
const router = useRouter();

const drawer = ref<boolean>(false);

// ----------------------------------------------------------------
// Watch
// ----------------------------------------------------------------

watch(
  () => props.multipleHeritageDialog,
  (newValue) => {
    if (newValue) {
      drawer.value = newValue;
    }
  },
);

// ----------------------------------------------------------------
// Lifecycle
// ----------------------------------------------------------------

onMounted(async () => {});

// ----------------------------------------------------------------
// Functions
// ----------------------------------------------------------------

function close() {
  drawer.value = false;
  emits("multipleHeritageDialog", false);
}

async function goToSource(item) {
  let routeData;
  if (item.source.object === "Node") {
    routeData = router.resolve({
      path: `/${workspaceStore.currentWSlug}/${item.source.id}`,
      query: { tab: "metadata" },
    });
    window.open(routeData.href, "_blank");
  } else if (item.source.object === "Sample") {
    const node = sampleStore.sampleMap.get(item.source.id)?.value.node.id;
    routeData = router.resolve({
      path: `/${workspaceStore.currentWSlug}/${node}`,
      query: { tab: "sample" },
    });
    window.open(routeData.href, "_blank");
  }
}
</script>

<template>
  <v-dialog
    v-model="drawer"
    width="100%"
    style="max-width: 800px !important; max-height: 800px !important"
    @click:outside="emits('close')"
  >
    <v-card>
      <v-card-title class="d-flex">
        <v-sheet
          class="me-auto"
          style="overflow: hidden; white-space: nowrap; text-overflow: ellipsis"
        >
          Inherited values for the metadata: {{ currentItem?.field.name }}
        </v-sheet>
        <v-sheet>
          <v-btn
            icon="$close"
            density="comfortable"
            variant="plain"
            @click="close"
          />
        </v-sheet>
      </v-card-title>
      <v-card-text>
        <div class="d-flex flex-column ga-2 pa-2" style="max-height: 600px; overflow-x: auto">
          <div
            v-for="item in Object.values(Object.fromEntries(currentItem.values))"
            :key="item.id"
            class="d-flex justify-start"
          >
            <v-card class="flex-grow-1">
              <v-card-title>{{ String(item.value) }} </v-card-title>
              <v-card-text>
                <div class="d-flex justify-space-between">
                  <div>
                    From {{ item.source.object.toLowerCase() }}
                    <em>{{
                      item.source.name.length > 200
                        ? `${item.source.name.substring(0, 200)}...`
                        : item.source.name
                    }}</em>
                  </div>
                  <div>
                    <v-tooltip location="bottom" text="Go to source">
                      <template v-slot:activator="{ props: SourceProps }">
                        <v-btn
                          v-bind="SourceProps"
                          icon="mdi-open-in-new"
                          variant="text"
                          @click="goToSource(item)"
                        />
                      </template>
                    </v-tooltip>
                  </div>
                </div>
              </v-card-text>
            </v-card>
          </div>
        </div>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>
